﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using FreshMvvm;
using MvvmHelpers;
using Syncfusion.SfRotator.XForms;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FreshMVVMSFDataGrid.ViewModel
{
    public class RotatorViewModel : ViewModelBase
    {

        #region Property WizardTemplates

        private ObservableRangeCollection<TemplateViewModelBase> _wizardTemplates = new ObservableRangeCollection<TemplateViewModelBase>();

        public ObservableRangeCollection<TemplateViewModelBase> WizardTemplates
        {
            get
            {
                return _wizardTemplates;
            }
            set
            {
                _wizardTemplates = value;
            }
        }

        #endregion

        #region Property WizardIndex

        public int WizardIndex
        {
            get;
            set;
        }

        #endregion

        #region Property SelectedIndexChangedCommand

        public Command SelectedIndexChangedCommand
        {
            get
            {
                return new Command(async (indexAsDouble) =>
                {
                    //if (indexAsDouble != null)
                    //{
                    //    int index = (int)(double)indexAsDouble;
                    //    TemplateViewModelBase previousViewModel = null;
                    //    TemplateViewModelBase currentViewModel = _wizardTemplates[index];
                    //    if (index > 0)
                    //    {
                    //        int previousPageIndex = index - 1;
                    //        previousViewModel = _wizardTemplates[previousPageIndex];
                    //        if (previousViewModel is RotatorPage2ViewModel && currentViewModel is PlaceholderViewModel)
                    //        {
                    //            RotatorPage3ViewModel page3 = new RotatorPage3ViewModel
                    //            {
                    //                ButtonText1 = "Button 1",
                    //                ButtonText2 = "Button 2",
                    //                ButtonText3 = "Button 3",
                    //                ButtonText4 = "Button 4",
                    //                BackgroundColor = "Green"
                    //            };

                    //            _wizardTemplates.Remove(currentViewModel);
                    //            _wizardTemplates.Add(page3);
                    //            WizardIndex = index;
                    //            //RaisePropertyChanged("WizardTemplates");
                    //        }
                    //    }
                    //    else
                    //    {
                    //        previousViewModel = _wizardTemplates[0];
                    //    }
                    //}
                });
            }
        }

        #endregion
        
        public override async void Init(object initData)
        {
            base.Init(initData);

            List<TemplateViewModelBase> templates = new List<TemplateViewModelBase>();

            RotatorPage1ViewModel page1 = new RotatorPage1ViewModel
            {
                Name = "Page 1",
                Description = "Page 1 Description",
                PageNumber = 1,
                BackgroundColor = "Red"
            };
            templates.Add(page1);

            RotatorPage2ViewModel page2 = new RotatorPage2ViewModel
            {
                Choice1 = "Option 1",
                Choice2 = "Option 2",
                Choice3 = "Option 3",
                Choice4 = "Option 4",
                BackgroundColor = "Red"
            };
            templates.Add(page2);

            RotatorPage3ViewModel page3 = new RotatorPage3ViewModel
            {
                ButtonText1 = "Button 1",
                ButtonText2 = "Button 2",
                ButtonText3 = "Button 3",
                ButtonText4 = "Button 4",
                BackgroundColor = "Red"
            };
            templates.Add(page3);

            _wizardTemplates.ReplaceRange(templates);
        }

    }
}